#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys, getopt, glob
import PIL.Image as pim

type = "JPEG"
outdir = "."
width = height = 0

opts, pattern = getopt.getopt(sys.argv[1:], "t:o:w:h:")
for opt in opts:
   if opt[0] == "-t": type = opt[1]
   elif opt[0] == "-o": outdir = opt[1]
   elif opt[0] == "-w": width = int(opt[1])
   elif opt[0] == "-h": height = int(opt[1])

try:
   tmp = pim.new("RGB", (1,1))
   tmp.save("/dev/null", type)
except:
   print >> sys.stderr, "ОШИБКА: формат %s не поддерживается" % type
   sys.exit()

if not pattern: pattern = "."

filelist = []
for entry in pattern:
   if entry[-1] == "/": entry = entry[:-1]
   if os.path.isdir(entry): entry += "/*"
   filelist.extend(glob.glob(entry))

for file in filelist:
   if not os.path.isfile(file): continue
   try:
      im = pim.open(file)
   except IOError: continue

   if not (width and height):
      if width: height = width * im.size[1] / im.size[0]
      elif height: width = height * im.size[0] / im.size[1]
      else: 
         width = im.size[0] 
	 height = im.size[1]

   resized = im.resize((width, height), pim.ANTIALIAS)
   name, ext = os.path.splitext(file)
   name = name.split("/")[-1]
   outfile = "%s/%s.%s" % (outdir, name, type.lower())
   resized.save(outfile)
   print "%s (%s, %dx%d) -> %s (%s, %dx%d)" % (file, 
         im.format, im.size[0], im.size[1], 
	 outfile, type, width, height)

